/// <reference types="express" />
import { SecurityProvider } from "./SecurityProvider";
import { Module } from "./Module";
import { Request, Response } from "express";
export declare abstract class SecurityModule extends Module {
    protected provider: SecurityProvider;
    getSecurityProvider(): SecurityProvider;
    activate(redirectRootToEntry?: boolean): void;
    protected abstract registerURLProvider(req: Request): any;
    protected abstract forgotURLProvider(req: Request): any;
    protected abstract entryURLProvider(req: Request): any;
    protected abstract logoutURLProvider(req: Request): any;
    protected abstract loginURLProvider(req: Request): any;
    protected abstract registerRequestHandler(req: Request, res: Response): any;
    protected abstract forgotRequestHandler(req: Request, res: Response): any;
    protected abstract entryRequestHandler(req: Request, res: Response): any;
    protected abstract loginRequestHandler(req: Request, res: Response): any;
}
