"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var SecurityProvider_1 = require("./SecurityProvider");
var Module_1 = require("./Module");
var SecurityModule = (function (_super) {
    __extends(SecurityModule, _super);
    function SecurityModule() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SecurityModule.prototype.getSecurityProvider = function () {
        return this.provider;
    };
    SecurityModule.prototype.activate = function (redirectRootToEntry) {
        var me = this;
        me.provider = new SecurityProvider_1.SecurityProvider(me.app, {
            loginURLProvider: me.loginURLProvider.bind(me),
            logoutURLProvider: me.logoutURLProvider.bind(me),
            entryURLProvider: me.entryURLProvider.bind(me),
            entryRequestHandler: me.entryRequestHandler.bind(me),
            loginRequestHandler: me.loginRequestHandler.bind(me),
            registerURLProvider: me.registerURLProvider.bind(me),
            registerRequestHandler: me.registerURLProvider.bind(me),
            forgotURLProvider: me.forgotURLProvider.bind(me),
            forgotRequestHandler: me.forgotRequestHandler.bind(me)
        });
        if (redirectRootToEntry === true) {
            me.provider.addRedirectToEntry("/");
        }
        me.provider
            .activate();
    };
    return SecurityModule;
}(Module_1.Module));
exports.SecurityModule = SecurityModule;
//# sourceMappingURL=SecurityModule.js.map